#!/usr/bin/python3
# -*- coding: iso-8859-1 -*-
#xsetaseta@gmail.com
# pip install matplotlib
# pip uninstall serial
# pip install pyserial
#version para sensores externos via RF

#=====================================================


import matplotlib
matplotlib.use('agg')
import matplotlib.pyplot as plt

import numpy as np   
import time

listaTemp2=[]
listaPres2=[]
lista24=[]


nombreFichero="Temp20"+time.strftime("%y_%m_%d")+".csv"
print ("Abriendo "+ nombreFichero)
DatosT=[]
DatosP=[]

for horax in range(0,24):
    for minutox in range(0,60):
        DatosT.append("-")
        DatosP.append("-")

try:
    f = open(nombreFichero,'r')
except IOError:
    print ("ERROR fichero", nombreFichero)
    sys.exit()
    
linea="-"
while linea!="":
    linea=f.readline()
    #print(linea)
    xlinea=linea.split(",")
    if len(xlinea)>4:
        horax=int(xlinea[0])
        minutox=int(xlinea[1])
        x=horax*60+minutox
        try:
            DatosT[x]=float(xlinea[2])
        except ValueError:
            DatosT[x]="-"  
            
        try:
            DatosP[x]=float(xlinea[3])
        except ValueError:
            DatosP[x]="-"      
        
        
        if DatosT[x]<-60 or DatosT[x]>100 or DatosP[x]<200 or DatosP[x]>2200:
            DatosT[x]="-"
            DatosP[x]="-"

f.close()
print ("Cerrando "+ nombreFichero)
print (time.strftime("DIA->%m_%d"))



ultimoT=0
ultimoP=935.0


for horax in range(0,24):
    x=horax*60+5

    if DatosT[x]=="-":
        miT=ultimoT
    else:
        miT=DatosT[x]
        ultimoT=miT
          
    if DatosP[x]=="-":
        miP=ultimoP
    else:
        miP=DatosP[x]
        ultimoP=miP  
        
    print("PRE - TEMP",horax,x,DatosT[x],DatosP[x],"==>",miT,miP)
    listaPres2.append(miP)
    listaTemp2.append(miT)


for horax in range(0,len(listaPres2)):
        #listaPres2x.append(str(horax)+":00")
        lista24.append(str(horax))
        
#_______________PRESION-2_______________________________

plt.rc('axes', labelsize=10)
plt.rc('xtick', labelsize=9)    

fig = plt.figure()                                                               
ax2 = fig.add_subplot(1,1,1)
major_ticks = np.arange(0, 24)                                              
ax2.set_xticks(major_ticks)
ax2.grid(which='major', alpha=1) 
ax2.set(ylabel='Bares')
ax2.set(xlabel='Hora')
ax2.set_title( time.strftime("%d/%m/20%y") )

plt.plot(lista24,listaPres2,'-',color = "green",label="Presin")
#plt.plot(listaPres2, lw='1', c='y', marker='o', ms=10, mfc='red')
plt.xlim(0,23)
plt.ion()

ax2.legend()
nombreFicheroP="xbar.png"
plt.savefig(nombreFicheroP,dpi=75)
print(nombreFicheroP)

#_______________TEMPERATURA-2_______________________________

#plt.rc('font', size=7) 
plt.rc('axes', labelsize=10)
plt.rc('xtick', labelsize=8)   
plt.rc('ytick', labelsize=9)
 
fig = plt.figure()                                                               
ax1 = fig.add_subplot(1,1,1)
major_ticks = np.arange(0, 24)                                              
ax1.set_xticks(major_ticks)
ax1.grid(which='major', alpha=1) 
ax1.set(ylabel='Temperatura')
ax1.set(xlabel='Hora')
ax1.set_title( time.strftime("%d/%m/20%y") )

plt.plot(lista24,listaTemp2,'-',color = "red",label="Grados")
#plt.plot(lista24,listaTemp2, lw='1', c='r', marker='o', ms=2,label="Grados")
plt.xlim(0,23)
plt.ion()

ax1.legend()

nombreFicheroT="xgrados.png"
plt.savefig(nombreFicheroT,dpi=75)
print(nombreFicheroT)

